SystemOrganization addCategory: #'OB-Filesystem-Actors'!
SystemOrganization addCategory: #'OB-Filesystem-Nodes'!
SystemOrganization addCategory: #'OB-Filesystem-Tests'!

!OBBrowser class methodsFor: '*ob-filesystem-initializing' stamp: 'cwp 5/27/2004 12:14'!
registerFileBrowser
	TheWorldMenu registerOpenCommand: {'File Browser'. {self. #browseFileSystem}}.! !

!OBBrowser class methodsFor: '*ob-filesystem-convenience' stamp: 'cwp 1/31/2004 10:21'!
browseFileSystem
	^ self 
		browse: #FileSystem
		fromRoot: (OBDirectoryNode on: FileDirectory root)
		select: (OBDirectoryNode default).
! !

OBCodeNode subclass: #OBClassAwareNode
	instanceVariableNames: 'classRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Nodes'!

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 3/19/2004 20:52'!
isDescendantOfClassCat: aClassCategoryNode
	^ (context categoryOf: self classRef) = aClassCategoryNode name! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 3/21/2004 22:48'!
theClassName
	^ self classRef name! !

!OBClassAwareNode methodsFor: 'nodes' stamp: 'cwp 3/21/2004 22:25'!
classNode
	^ OBClassNode on: self classRef inContext: context! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 12:07'!
isDescendantOfExtCat: anExtensionCatNode 
	^ (anExtensionCatNode context classExists: self classRef) not 
		and: [(anExtensionCatNode context categoriesForClass: self classRef) isEmpty not]! !

!OBClassAwareNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 23:41'!
browse
	Browser fullOnClass: self classRef theClass! !

!OBClassAwareNode methodsFor: 'actions' stamp: 'cwp 3/14/2004 19:10'!
chaseVars
	OBBrowser 
		browse: #ChaseVariables 
		fromRoot: self classNode
		panes: 3! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 5/11/2004 10:14'!
theNonMetaClassName
	^ self nonMetaClassRef name! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 3/21/2004 21:29'!
isDescendantOfClass: aClassNode
	^ self theClassName = aClassNode theClassName! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 5/11/2004 10:01'!
nonMetaClassRef
	^ self classRef copy beNonMeta! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 3/22/2004 22:59'!
classRef	
	^ classRef! !

OBNode subclass: #OBDirectoryNode
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Nodes'!

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:51'!
name
	^ directory localName! !

!OBDirectoryNode class methodsFor: 'instance creation' stamp: 'cwp 1/31/2004 10:17'!
default
	^ self on: (FileDirectory default)! !

!OBDirectoryNode class methodsFor: 'initializing' stamp: 'cwp 5/27/2004 12:33'!
initialize
	OBBrowser registerFileBrowser! !

!OBDirectoryNode class methodsFor: 'instance creation' stamp: 'cwp 3/10/2004 23:27'!
root
	^ self on: (FileDirectory root)! !

!OBDirectoryNode class methodsFor: 'instance creation' stamp: 'cwp 11/28/2003 21:57'!
on: aFileDirectory
	^ self new directory: aFileDirectory! !

!OBDirectoryNode methodsFor: 'accessing' stamp: 'cwp 1/31/2004 10:15'!
path
	^ directory fullName! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/15/2003 21:37'!
nodeForEntry: anEntry
	^ (anEntry at: 4)
		ifTrue: [OBDirectoryNode on: (directory directoryNamed: (anEntry at: 1))]
		ifFalse: [OBFileNode on: (directory fullNameFor: (anEntry at: 1))]! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 17:43'!
textForDirectory: aFilename
	| entry |
	entry _ directory entryAt: aFilename.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: aFilename); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 11/28/2003 21:57'!
directory: aFileDirectory
	directory _ aFileDirectory! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 1/31/2004 15:15'!
shouldDisplay: name
	^ name first ~= $.! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 18:01'!
displayEntry: entry on: aStream
	aStream nextPutAll: (entry at: 1).
	aStream nextPutAll: ' - '.
	aStream nextPutAll: (entry at: 5) asString, ' bytes'.
	aStream cr.! !

!OBDirectoryNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:59'!
hash
	^ self path hash! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 1/31/2004 15:14'!
files
	^ directory fileNames 
		select: [:name | self shouldDisplay: name]
		thenCollect: [:name | OBFileNode on: (directory fullNameFor: name)]
	! !

!OBDirectoryNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:59'!
= other
	^ self path = other path! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 1/31/2004 10:14'!
isAncestorOf: aNode
	^ aNode path beginsWith: self path! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 1/31/2004 15:14'!
directories
	^ directory directoryNames 
		select: [:name | self shouldDisplay: name]
		thenCollect: [:name | OBDirectoryNode on: (directory directoryNamed: name)]
	! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:47'!
text
	| entry |
	entry _ directory directoryEntry.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: (entry at: 1)); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

OBNode subclass: #OBFileNode
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Nodes'!

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:21'!
openFile
	^ FileStream oldFileNamed: path! !

!OBFileNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:58'!
hash
	^ self path hash! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/7/2003 20:00'!
name
	^ FileDirectory localNameFor: path! !

!OBFileNode class methodsFor: 'instance creation' stamp: 'cwp 12/7/2003 19:43'!
on: aPath
	^ self new path: aPath! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 12/7/2003 19:44'!
path: aPath
	path _ aPath! !

!OBFileNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:58'!
= other
	^ self path = other path! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 1/24/2004 00:16'!
path
	^ path! !

!OBFileNode methodsFor: 'actions' stamp: 'cwp 3/14/2004 17:17'!
delete
	FileDirectory deleteFilePath: path.
	self signalDeletion.! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 2/3/2004 22:30'!
actions
	^ Array with: (self action: #delete withLabel: 'delete')! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 5/2/2004 13:58'!
text: aText
	| file |
	file _ FileStream forceNewFileNamed: path.
	file
		nextPutAll: aText asString;
		close! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 2/12/2004 20:52'!
text
	| file text |
	file _ self openFile.
	file ifNil: [^ 'Error opening file'].
	text _ file contentsOfEntireFile.
	file close.
	^ text! !

OBBrowserTest subclass: #OBDirectoryBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Tests'!

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 10:13'!
epsilonNode
	^ OBFileNode 
		on: ((OBDirectoryResource current dataDir directoryNamed: 'delta') fullNameFor: 'epsilon')! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:19'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: ''.
	! !

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 12/17/2003 15:14'!
node
	^ OBDirectoryNode on: OBDirectoryResource current dataDir! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 10:13'!
testJumpToEpsilon
	| node |
	node _ self epsilonNode.
	model jumpTo: node.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertListAt: 2 contains: #(epsilon).
	self assertCurrentItemIs: 'epsilon'.! !

!OBDirectoryBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:09'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 12/18/2003 18:33'!
metaGraph
	^ OBMetaGraphBuilder default fileSystemBrowser! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 17:01'!
testSelectAlpha
	self select: 'alpha'.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: 'alpha'! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 23:33'!
testMenuItems
	self select: 'alpha'.
	self assertMenuContains: 'delete'! !

!OBMetaGraphBuilder methodsFor: '*ob-filesystem-browsers' stamp: 'cwp 3/6/2004 21:26'!
fileSystemBrowser
	| directory file |
	directory _ OBMetaNode named: 'Directory'.
	file _ OBMetaNode named: 'File'.
	file 
		addActor: OBNodeActor new;
		addActor: OBFileRegistryActor new.
	directory 
		childAt: #directories put: directory;
		childAt: #files put: file.
	^ directory! !

!OBMetaGraphBuilder methodsFor: '*ob-filesystem-browsers' stamp: 'cwp 5/27/2004 13:26'!
installFilesystemGraphs
	OBBrowser metaGraphAt: #FileSystem put: self fileSystemBrowser! !

TestResource subclass: #OBDirectoryResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Tests'!

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
tearDown
	self dataDir recursiveDelete! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:44'!
dataDirName
	^ 'obtest'! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ FileDirectory default directoryNamed: self dataDirName! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2004 19:23'!
setUp
	| dir delta |
	dir _ self dataDir.
	dir assureExistence.
	#(alpha beta gamma) do: [:filename | | file | file _ dir forceNewFileNamed: filename.
							  file nextPutAll: filename.
							  file close].
	delta _ dir directoryNamed: 'delta'.
	delta assureExistence.
	(delta directoryNamed: 'epsilon') assureExistence! !

TestCase subclass: #OBFileNodeEditTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Tests'!

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:30'!
createFile
	| file |
	file _ FileStream newFileNamed: self dataFile.
	file
		nextPutAll: 'omega';
		close.
! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:27'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'omega'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:39'!
testAcceptText
	| file |
	node text: 'foo'.
	file _ FileStream readOnlyFileNamed: self dataFile.
	self assert: file contents = 'foo'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	self createFile.
	node _ OBFileNode on: self dataFile.
	! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:28'!
tearDown
	FileDirectory deleteFilePath: self dataFile! !

TestCase subclass: #OBDirectoryNodeTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Tests'!

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testName
	self assert: node name = 'obtest'! !

!OBDirectoryNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:01'!
testDirectoryNodes
	| children |
	children _ node directories collect: [:n | n name].
	self assert: children = #(delta)
	! !

!OBDirectoryNodeTest methodsFor: 'data' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ OBDirectoryResource current dataDir! !

!OBDirectoryNodeTest methodsFor: 'running' stamp: 'cwp 12/15/2003 21:39'!
setUp
	node _ OBDirectoryNode on: self dataDir.! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testText
	self assert: (node text endsWith: '
----------
alpha - 5 bytes
beta - 4 bytes
delta - 0 bytes
gamma - 5 bytes
')
! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 14:49'!
testFileNodes
	| children |
	children _ node files.
	self assert: (children collect: [:n | n name]) = #(alpha beta gamma)
	! !

TestCase subclass: #OBFileRegistryActorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Tests'!

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
assertActions: actions include: required
	| labels |
	labels _ actions collect: [:act | act label].
	self assert: (required includesAllOf: labels)! !

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
testTextFile
	| actor node actions |
	actor _ OBFileRegistryActor new.
	node _ OBFileNode on: (FileDirectory default fullNameFor: 'foo.txt').
	actions _ actor actionsForNode: node.
	self assertActions: actions include: #('add file to new zip' 'compress file').! !

TestCase subclass: #OBFileNodeTest
	instanceVariableNames: 'node notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Tests'!

!OBFileNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBFileNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:41'!
testText
	self assert: (node text = 'alpha')! !

!OBFileNodeTest methodsFor: 'running' stamp: 'cwp 5/2/2004 13:49'!
tearDown
	| file |
	file _ FileStream forceNewFileNamed: self dataFile.
	file
		nextPutAll: 'alpha';
		close.! !

!OBFileNodeTest methodsFor: 'callbacks' stamp: 'cwp 1/23/2004 23:15'!
notification: aNotification
	notification _ aNotification! !

!OBFileNodeTest methodsFor: 'running' stamp: 'cwp 12/8/2003 22:15'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'alpha'! !

!OBFileNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:41'!
testName
	self assert: node name = 'alpha'! !

!OBFileNodeTest methodsFor: 'running' stamp: 'cwp 12/15/2003 21:40'!
setUp
	node _ OBFileNode on: self dataFile.! !

!OBFileNodeTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 17:18'!
testDelete
	| actions delete |
	actions _ node actions.
	delete _ actions detect: [:a | a label = 'delete'] ifNone: [self signalFailure: 'No delete action'].
	delete monitor: self.
	delete trigger.
	self deny: ((FileDirectory default) fileExists: self dataFile).
	self assert: notification class = OBNodeDeleted.
	self assert: notification node = node.

	! !

OBActor subclass: #OBFileRegistryActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Filesystem-Actors'!

!OBFileRegistryActor commentStamp: 'cwp 3/5/2004 12:17' prior: 0!
This Actor serves as an intermediary between OBFileNodes and the file reader registry maintained by FileList. It makes the registries services available as file node actions.!

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 3/10/2004 23:37'!
actionsForNode: aFileNode
	| services actions |
	services _ FileList itemsForFile: aFileNode path.
	services do: [:svc | svc addDependent: self].
	actions _ services collect: [:ea | OBAction
							label: ea label
							buttonLabel: ea buttonLabel
							receiver: ea
							selector: ea requestSelector
							arguments: (Array with: aFileNode path)].
	^ actions! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:05'!
update: aParameter
	(aParameter == #fileListChanged) ifTrue: [self updateFileList].
	super update: aParameter! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 22:42'!
updateFileList
	OBListChanged signal! !
OBDirectoryNode initialize!
